Package org.apache.wiki.util

## Class HttpUtil

- java.lang.Object
- - org.apache.wiki.util.HttpUtil

    public final class HttpUtil
    extends java.lang.Object

Contains useful utilities for some common HTTP tasks.

Since:
  2.1.61.

### Method Summary

All Methods Static Methods Concrete Methods
`static boolean` `checkFor304​(javax.servlet.http.HttpServletRequest req, java.lang.String pageName, java.util.Date lastModified)` If returns true, then should return a 304 (HTTP_NOT_MODIFIED)
`static void` `clearCookie​(javax.servlet.http.HttpServletResponse response, java.lang.String cookieName)`
`static java.lang.String` `createETag​(java.lang.String pageName, java.util.Date lastModified)` Creates an ETag based on page information.
`static java.lang.String` `getAbsoluteUrl​(javax.servlet.http.HttpServletRequest request)` Generate an absolute URL based solely on the given HttpServletRequest.
`static java.lang.String` `getAbsoluteUrl​(javax.servlet.http.HttpServletRequest request, java.lang.String relativeUrl)` Generates an absolute URL based on the given HttpServletRequest and a relative URL.
`static java.lang.String` `getRemoteAddress​(javax.servlet.http.HttpServletRequest req)` returns the remote address by looking into `x-forwarded-for` header or, if unavailable, into `ServletRequest.getRemoteAddr()`.
`static java.lang.String` `guessValidURI​(java.lang.String uri)` Attempts to form a valid URI based on the string given.
`static boolean` `isIPV4Address​(java.lang.String name)` Verifies whether a String represents an IPv4 address.
`static java.lang.String` `retrieveCookieValue​(javax.servlet.http.HttpServletRequest request, java.lang.String cookieName)` Attempts to retrieve the given cookie value from the request.
`static java.lang.String` `safeGetQueryString​(javax.servlet.http.HttpServletRequest request, java.nio.charset.Charset contentEncoding)` Returns the query string (the portion after the question mark).

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### getRemoteAddress

    public static java.lang.String getRemoteAddress​(javax.servlet.http.HttpServletRequest req)

returns the remote address by looking into `x-forwarded-for` header or, if unavailable, into `ServletRequest.getRemoteAddr()`.

Parameters:
  `req` - http request
Returns:
  remote address associated to the request.

#### retrieveCookieValue

    public static java.lang.String retrieveCookieValue​(javax.servlet.http.HttpServletRequest request,
                                                       java.lang.String cookieName)

Attempts to retrieve the given cookie value from the request. Returns the string value (which may or may not be decoded correctly, depending on browser!), or null if the cookie is not found. The algorithm will automatically trim leading and trailing double quotes, if found.

Parameters:
  `request` - The current request
  `cookieName` - The name of the cookie to fetch.
Returns:
  Value of the cookie, or null, if there is no such cookie.

#### createETag

    public static java.lang.String createETag​(java.lang.String pageName,
                                              java.util.Date lastModified)

Creates an ETag based on page information. An ETag is unique to each page and version, so it can be used to check if the page has changed. Do not assume that the ETag is in any particular format.

Parameters:
  `pageName` - The page name for which the ETag should be created.
  `lastModified` - The page last modified date for which the ETag should be created.
Returns:
  A String depiction of an ETag.

#### checkFor304

    public static boolean checkFor304​(javax.servlet.http.HttpServletRequest req,
                                      java.lang.String pageName,
                                      java.util.Date lastModified)

If returns true, then should return a 304 (HTTP_NOT_MODIFIED)

Parameters:
  `req` - the HTTP request
  `pageName` - the wiki page name to check for
  `lastModified` - the last modified date of the wiki page to check for
Returns:
  the result of the check

#### guessValidURI

    public static java.lang.String guessValidURI​(java.lang.String uri)

Attempts to form a valid URI based on the string given. Currently it can guess email addresses (mailto:). If nothing else is given, it assumes it to be an http:// url.

Parameters:
  `uri` - URI to take a poke at
Returns:
  Possibly a valid URI
Since:
  2.2.8

#### safeGetQueryString

    public static java.lang.String safeGetQueryString​(javax.servlet.http.HttpServletRequest request,
                                                      java.nio.charset.Charset contentEncoding)

Returns the query string (the portion after the question mark).

Parameters:
  `request` - The HTTP request to parse.
Returns:
  The query string. If the query string is null, returns an empty string.
Since:
  2.1.3 (method moved from WikiEngine on 2.11.0.M6)

#### isIPV4Address

    public static boolean isIPV4Address​(java.lang.String name)

Verifies whether a String represents an IPv4 address. The algorithm is extremely efficient and does not allocate any objects.

Parameters:
  `name` - the address to test
Returns:
  the result

#### clearCookie

    public static void clearCookie​(javax.servlet.http.HttpServletResponse response,
                                   java.lang.String cookieName)

#### getAbsoluteUrl

    public static java.lang.String getAbsoluteUrl​(javax.servlet.http.HttpServletRequest request,
                                                  java.lang.String relativeUrl)

Generates an absolute URL based on the given HttpServletRequest and a relative URL. This method takes into account various headers like X-Forwarded-Host, X-Forwarded-Proto, and X-Forwarded-Server to construct the absolute URL.

Parameters:
  `request` - The HttpServletRequest object, used to obtain scheme, server name, and port.
  `relativeUrl` - The relative URL to be appended to the base URL. Can be null.
Returns:
  The absolute URL as a String.
Since:
  2.12.2

#### getAbsoluteUrl

    public static java.lang.String getAbsoluteUrl​(javax.servlet.http.HttpServletRequest request)

Generate an absolute URL based solely on the given HttpServletRequest. This is a convenience method that calls `getAbsoluteUrl(HttpServletRequest, String)` with a null relative URL.

Parameters:
  `request` - The HttpServletRequest object, used to obtain scheme, server name, and port.
Returns:
  The absolute URL as a String.
Since:
  2.12.2
See Also:
  `getAbsoluteUrl(HttpServletRequest, String)`